

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <stdio.h>
#include <stdbool.h>

#define DXMENU_CONFIG_NAME                  "dxmenu-config"
#define DXMENU_CONFIG_PATH                  "config_path"
#define DXMENU_CONFIG_JSON_MENU_PATH        "json_menu_path"
#define DXMENU_CONFIG_FONT                  "font"
#define DXMENU_CONFIG_BACKGROUND_COLOR      "background_color"
#define DXMENU_CONFIG_FOREGROUND_COLOR      "foreground_color"
#define DXMENU_CONFIG_SELBACKGROUND_COLOR   "selbackground_color"
#define DXMENU_CONFIG_SELFOREGROUND_COLOR   "selforeground_color"
#define DXMENU_CONFIG_SEPARATOR_COLOR       "separator_color"
#define DXMENU_CONFIG_BORDER_COLOR          "border_color"
#define DXMENU_CONFIG_WIDTH_PIXELS          "width_pixels"
#define DXMENU_CONFIG_HEIGHT_PIXELS         "height_pixels"
#define DXMENU_CONFIG_BORDER_PIXELS         "border_pixels"
#define DXMENU_CONFIG_SEPARATOR_PIXELS      "separator_pixels"
#define DXMENU_CONFIG_GAP_PIXELS            "gap_pixels"
#define DXMENU_CONFIG_MAX_ITEMS             "max_items"
#define DXMENU_CONFIG_TRIANGLE_WIDTH        "triangle_width"
#define DXMENU_CONFIG_TRIANGLE_HEIGHT       "triangle_height"
#define DXMENU_CONFIG_ICONPADDING           "iconpadding"
#define DXMENU_CONFIG_HORZPADDING           "horzpadding"
#define DXMENU_CONFIG_ALIGNMENT             "alignment"
#define DXMENU_CONFIG_HASICON               "hasicon"
#define DXMENU_CONFIG_TINT2EXECP            "tint2execp"

/* configuration structure */
struct dxmenu_config {

    char** params;
   
    // config file path (used by opts)
    char* config_path;
    
    // json menu path
    char* json_menu_path;
   
	/* the values below are set by config.h */
	char *font;
	char *background_color;
	char *foreground_color;
	char *selbackground_color;
	char *selforeground_color;
	char *separator_color;
	char *border_color;
	int width_pixels;
	int height_pixels;
	int border_pixels;
	int separator_pixels;
	int gap_pixels;
	int max_items;
	int triangle_width;
	int triangle_height;
	int iconpadding;
	int horzpadding;
	int alignment;

	/* the values below are set by options */
	int monitor;
	int posx, posy;         /* rootmenu position */

	/* the value below is computed by dxmenu */
	int iconsize;
	
	/* whether the menu has item with icons */
	bool hasicon;
	
	/* whether the menu is displayed as an executor plugin for tint2 */
	bool tint2execp;      
};

int dxmenu_config_init(struct dxmenu_config* conf);
int dxmenu_config_load(char const* path, struct dxmenu_config* conf);
int dxmenu_config_load_file(FILE* file, struct dxmenu_config* conf);
int dxmenu_config_free(struct dxmenu_config* conf);
int dxmenu_config_fullpaths(struct dxmenu_config* config);
void dxmenu_config_load_from_args(struct dxmenu_config* config, int argc, char** argv);

#endif
